# This file was generated by liblab | https://liblab.com/

from .utils.validator import Validator
from .utils.base_service import BaseService
from ..net.transport.serializer import Serializer
from ..models.utils.cast_models import cast_models
from ..models.current_location_ok_response import (
    CurrentLocationOkResponse,
    CurrentLocationOkResponseGuard,
)


class CurrentService(BaseService):

    @cast_models
    def current_location(
        self, access_key: str, query: str = None
    ) -> CurrentLocationOkResponse:
        """\`Current\` endpoint let you fetch the weather stats of the metioned location in the \`query\` parameter.

        :param access_key: [Required] Use this parameter to pass your unique API access key to the API.
        :type access_key: str
        :param query: [Required] Use this parameter to pass a single location or multiple semicolon-separated location identifiers to the API. Learn more about the Query Parameter., defaults to None
        :type query: str, optional
        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        :return: 200 OK – Current Location / 200 OK – Multiple current locations / 200 OK – Location Identifiers
        :rtype: CurrentLocationOkResponse
        """

        Validator(str).validate(access_key)
        Validator(str).is_optional().validate(query)

        serialized_request = (
            Serializer(f"{self.base_url}/current", self.get_default_headers())
            .add_query("access_key", access_key)
            .add_query("query", query)
            .serialize()
            .set_method("GET")
        )

        response = self.send_request(serialized_request)

        return CurrentLocationOkResponseGuard.return_one_of(response)
